* $Id: gmss.s,v 1.1 1994/09/13 21:58:45 JACK Exp $

	.include	iocscall.mac
	.include	doscall.mac
	.include	gm_internal.mac

*
	.text
program_text_start:
	.data
program_data_start:
	.bss
program_bss_start:
	.stack
program_stack_start:
	.text
*

*-------------------------------------------------------------------------------
* IR[h̒`

	.offset	0
EXIT_NO_ERROR		.ds.b	1
EXIT_HELP		.ds.b	1
EXIT_ERROR_OPTION	.ds.b	1
EXIT_ERROR_SETBLOCK	.ds.b	1
EXIT_ERROR_MALLOC	.ds.b	1
EXIT_ERROR_MFREE	.ds.b	1
EXIT_ERROR_GM_NOT_KEEP	.ds.b	1
	.text

*-------------------------------------------------------------------------------
* ^CgbZ[W

	.data
message_title:
	.dc.b	'GM Set Screen version 0.62 programmed by JACK',13,10
	.dc.b	0

*-------------------------------------------------------------------------------
* }N`

_TO_SUPER	.macro
* X[p[oCU[[h
	clr.l	-(sp)
	DOS	__SUPER
	addq.l	#4,sp
	move.l	d0,-(sp)
	.endm

_TO_USER	.macro
		.local	super_end
* [U[[h
	move.l	(sp)+,d0
	bmi	super_end
	move.l	d0,-(sp)
	DOS	__SUPER
	addq.l	#4,sp
super_end:
	.endm

*-------------------------------------------------------------------------------
* 烁CvO

	.bss
	.even
parameter_a0:
	.ds.l	1
parameter_a1:
	.ds.l	1
parameter_a2:
	.ds.l	1
parameter_a3:
	.ds.l	1
parameter_a4:
	.ds.l	1
program_top_address:
	.ds.l	1
program_size:
	.ds.l	1

	.stack
	.ds.l	1024
user_stack:

	.text
program_start:
	lea	user_stack,sp
	movem.l	a0-a4,parameter_a0
	lea	$10(a0),a0
	sub.l	a0,a1
	move.l	a1,-(sp)
	move.l	a0,-(sp)
	DOS	__SETBLOCK
	addq.l	#8,sp
	tst.l	d0
	bmi	program_error_setblock
	bsr	program_ver_check

	move.l	parameter_a0,a0
	move.l	parameter_a1,a1
	lea	$100(a0),a0
	move.l	a0,program_top_address
	sub.l	a0,a1			* a1.l = vOTCY
	move.l	a1,program_size

	move.l	parameter_a2,a0
switch_check:
	clr.l	d7			* d7.l = IvVXCb`
	tst.b	(a0)+
switch_check_loop:
	bsr	get_character
	beq	switch_check_end
	cmp.b	#'-',d0
	beq	switch_check_option

	.ifdef	__SLASH__
	cmp.b	#'/',d0
	beq	switch_check_option
	.endif

	bra	switch_check_error
switch_check_option:
	bsr	option_check
	bra	switch_check_loop
switch_check_error:
	bset.l	#OPT_ERR,d7

switch_check_end:
	tst.l	d7
	bne	exec_option
	bra	exec_option		* XCb`ȂĂN

*-------------------------------------------------------------------------------
* IvVXCb`̒`

	.offset	0
OPT_C	.ds.b	1	* OtBbÑNA
OPT_R	.ds.b	1	* OtBbNEXN[EWX^̏
OPT_G	.ds.b	1	* OtBbN\̃IIt
OPT_S	.ds.b	1	* USjFOtBbN̏ck
OPT_T	.ds.b	1	* OtBbÑg[_E
OPT_M	.ds.b	1	* ʃ[h̏
OPT_V	.ds.b	1	* o[W\AbZ[W̕\
OPT_HLP	.ds.b	1	* wv\
OPT_ERR	equ	31	* XCb`ẘԈႢȂǁFɍŏʃrbg
	.text

*-------------------------------------------------------------------------------
* IvVXCb`̓ǂݎ聕ݒ

	.text
option_check:
	tst.b	(a0)
	bne	option_check_loop
	bset.l	#OPT_ERR,d7
	bra	option_check_end
option_check_loop:
	move.b	(a0),d0
	beq	option_check_end
	tst.b	(a0)+
	bsr	toupper
	cmp.b	#' ',d0
	beq	option_check_end
	cmp.b	#$09,d0
	beq	option_check_end
	cmp.b	#'V',d0
	beq	opt_v
	cmp.b	#'C',d0
	beq	opt_c
	cmp.b	#'R',d0
	beq	opt_r
	cmp.b	#'G',d0
	beq	opt_g
	cmp.b	#'S',d0
	beq	opt_s
	cmp.b	#'T',d0
	beq	opt_t
	cmp.b	#'M',d0
	beq	opt_m
	cmp.b	#'H',d0
	beq	opt_h
	bra	opt_err

opt_c:
	bset.l	#OPT_C,d7
	bra	option_check_loop

opt_r:
	bset.l	#OPT_R,d7
	bra	option_check_loop

	.bss
	.even
opt_g_number:
	.ds.l	1
	.text
opt_g:
	bset.l	#OPT_G,d7
	lea	opt_g_number,a1
	move.l	#1,(a1)			* ftHg͂P炵
	moveq.l	#3,d0			* ǂݎ萔l̍ől
	bsr	opt_number
	bmi	opt_err			* őll̓ǂݎŃG[ł
	bra	option_check_loop

	.bss
	.even
opt_s_number:
	.ds.l	1
	.text
opt_s:
	bset.l	#OPT_S,d7
	lea	opt_s_number,a1
	clr.l	(a1)			* ftHg͂O炵
	moveq.l	#1,d0			* ǂݎ萔l̍ől
	bsr	opt_number
	bmi	opt_err			* őll̓ǂݎŃG[ł
	bra	option_check_loop

	.bss
	.even
opt_t_number:
	.ds.l	1
	.text
opt_t:
	bset.l	#OPT_T,d7
	lea	opt_t_number,a1
	move.l	#50,(a1)		* ftHg͂TO炵
	moveq.l	#100,d0			* ǂݎ萔l̍ől
	bsr	opt_number
	bmi	opt_err			* őll̓ǂݎŃG[ł
	bra	option_check_loop

opt_m:
	bset.l	#OPT_M,d7
	bra	option_check_loop

opt_v:
	bset.l	#OPT_V,d7
	bra	option_check_loop

opt_h:
	bset.l	#OPT_HLP,d7
	bset.l	#OPT_V,d7
	bra	option_check_loop

opt_err:
	bset.l	#OPT_ERR,d7
	bsr	skip_character		* ̃R}hC͕]ĂʂȂ̂Ő؂
	bra	option_check_loop

option_check_end:
	rts

*-------------------------------------------------------------------------------
* lǂݎă[Nɂ܂
*
* entry:
*   d0.l = ő吔l
*   a0.l = |C^
*   a1.l = lۑ郏[NGÃAhX
* return:
*   ccr:n = 0 ǂݎꂽ
*   ccr:n = 1 G[
* broken:
*   d0.l, d1.l

	.text
opt_number:
	bsr	skip_space		* XCb`̌ɃXy[XĂ
	cmp.b	#'-',(a0)
	beq	opt_number_next		* ̃XCb`炵
	bsr	option_get_number
	tst.l	d1
	beq	opt_number_end		* ftHg
	bmi	opt_number_end		* ől𒴂l̓ǂݎŃG[ł
	move.l	d0,(a1)
opt_number_end:
	tst.l	d1
	rts

opt_number_next:
	subq.l	#1,a0			* s߂߂
	cmp.b	#' ',(a0)
	beq	@f
	cmp.b	#$09,(a0)
	beq	@f
	addq.l	#1,a0			* Xy[XA^uȊO͖
@@:
	moveq.l	#0,d1
	bra	opt_number_end

*-------------------------------------------------------------------------------
* l̓ǂݎiPOij
*
* entry:
*   d0.l = ő吔l
*   a0.l = |C^
* return:
*   d0.l = liG[␔lĂȂ͕sj
*   d1.l = 0 lĂȂ
*   d1.l > 0 lꂽ
*   d1.l < 0 ُȕő吔l𒴂

option_get_number_register	reg	d2-d4

option_get_number:
	movem.l	option_get_number_register,-(sp)
	move.l	d0,d4
	clr.l	d0
	clr.l	d1
	clr.l	d3
option_get_number_loop:
	move.b	(a0),d1
	beq	option_get_number_check
	cmp.b	#' ',d1
	beq	option_get_number_check
	cmp.b	#$09,d1
	beq	option_get_number_check
	sub.b	#'0',d1
	bmi	option_get_number_error	* 0 ` 9͈̔͂łȂΓRG[łB
	cmp.b	#9+1,d1
	bcc	option_get_number_error
	moveq.l	#1,d3			* ǂݎtOI
	add.l	d0,d0
	move.l	d0,d2
	add.l	d0,d0
	add.l	d0,d0
	add.l	d2,d0
	add.l	d1,d0			* d0.l=d0.l*10 + d1.l
	tst.b	(a0)+			* |C^Pi߂
	bra	option_get_number_loop

option_get_number_check:
	tst.l	d3
	beq	option_get_number_end
	cmp.l	d4,d0			* ől𒴂Ă邩ȁH
	bls	option_get_number_end
option_get_number_error:
	moveq.l	#-1,d3			* G[
option_get_number_end:
	move.l	d3,d1
	movem.l	(sp)+,option_get_number_register
	rts

*-------------------------------------------------------------------------------
* vOsႤł

	.data
	.even
exec_table:
	.dc.l	title
	.dc.l	error
	.dc.l	help
	.dc.l	gm_keep_check
	.dc.l	graphic_onoff
	.dc.l	shrink
	.dc.l	tone
	.dc.l	clear
	.dc.l	scroll
	.dc.l	main
	.dc.l	0

	.ifdef	__DEBUG__
message_exit:
	.dc.b	'debug:ƏI܂B',13,10
	.dc.b	0
message_exit2:
	.dc.b	'debug:G[łB',13,10
	.dc.b	0
message_keeppr:
	.dc.b	'debug:ɏ풓Ⴂ܂B',13,10
	.dc.b	0
	.endif

exec_register	reg	d7/a1

	.text
exec_option:
	.ifdef	__DEBUG__
	bset.l	#OPT_V,d7
	.endif

	lea	exec_table,a1
exec_option_loop:
	move.l	(a1)+,d0
	beq	exec_option_end
	move.l	d0,a0
	jsr	(a0)
	tst.l	d0
	bne	exec_option_exit
	bra	exec_option_loop
exec_option_end:

	.ifdef	__DEBUG__
	pea	message_exit
	DOS	__PRINT
	addq.l	#4,sp
	.endif

	DOS	__EXIT
exec_option_exit:
	tst.l	d0
	bmi	exec_option_keeppr
	move.w	d0,-(sp)

	.ifdef	__DEBUG__
	pea	message_exit2
	DOS	__PRINT
	addq.l	#4,sp
	.endif

	DOS	__EXIT2
exec_option_keeppr:
	move.w	d0,-(sp)
	move.l	d1,-(sp)

	.ifdef	__DEBUG__
	pea	message_keeppr
	DOS	__PRINT
	addq.l	#4,sp
	.endif

	DOS	__KEEPPR

*-------------------------------------------------------------------------------
* 󔒕ȊÖꕶ𓾂
*
* return:
*   ccr:z  = 0 ꂽ
*   ccr:z  = 1 ͂܂
*     d0.b = (R[h)

	.text
get_character:
	move.b	(a0)+,d0
	beq	get_character_end
	cmp.b	#' ',d0
	beq	get_character
	cmp.b	#$09,d0
	beq	get_character
get_character_end:
	rts

*-------------------------------------------------------------------------------
* k܂Ń|C^i߂

	.text
skip_character:
	tst.b	(a0)
	beq	skip_character_end
	tst.b	(a0)+
	bra	skip_character
skip_character_end:
	rts

*-------------------------------------------------------------------------------
* Xy[XA^uǂݔ΂

	.text
skip_space:
	tst.b	(a0)+
	beq	skip_space_end
	cmp.b	#' ',-1(a0)
	beq	skip_space
	cmp.b	#$09,-1(a0)
	beq	skip_space
skip_space_end:
	subq.l	#1,a0
	rts

*-------------------------------------------------------------------------------
* At@xbg啶ɕϊ

	.text
toupper:
	cmp.b	#'a',d0
	bcs	toupper_end
	cmp.b	#'z'+1,d0
	bcc	toupper_end
	sub.b	#'a'-'A',d0
toupper_end:
	rts

*-------------------------------------------------------------------------------
* '-v' ݒ肳Ă鎞bZ[W\
*
* entry:
*   $04(sp) = ̃AhX

	.text
_vprint:
	btst.l	#OPT_V,d7
	beq	_vprint_end
	move.l	$04(sp),-(sp)
	DOS	__PRINT
	addq.l	#4,sp
_vprint_end:
	rts

*-------------------------------------------------------------------------------
* G[̃bZ[W\
*
* entry:
*   $04(sp) = ̃AhX

	.text
_error_print:
	move.l	$04(sp),-(sp)		* ڂ̖EEE
	DOS	__PRINT
	addq.l	#4,sp
_error_print_end:
	rts

*-------------------------------------------------------------------------------
* Ñ^Cg\

	.text
title:
	movem.l	exec_register,-(sp)
	clr.l	d0
	btst.l	#OPT_V,d7
	bne	title_print
	btst.l	#OPT_ERR,d7
	bne	title_print
	btst.l	#OPT_HLP,d7
	bne	title_print
	bra	title_end

title_print:
	pea	message_title
	DOS	__PRINT
	addq.l	#4,sp
	clr.l	d0
title_end:
	movem.l	(sp)+,exec_register
	rts

*-------------------------------------------------------------------------------
* XCb`̎w肪ԈẴG[bZ[W\

	.data
message_error:
	.dc.b	'XCb`̎w肪ԈĂ܂B',13,10
	.dc.b	'(-h Ńwv\܂B)',13,10
	.dc.b	0

	.text
error:
	movem.l	exec_register,-(sp)
	clr.l	d0
	btst.l	#OPT_ERR,d7
	beq	error_end

	pea	message_error
	bsr	_error_print
	addq.l	#4,sp

	moveq.l	#EXIT_ERROR_OPTION,d0
error_end:
	movem.l	(sp)+,exec_register
	rts

*-------------------------------------------------------------------------------
* wvbZ[W̕\

	.data
message_help:
	.dc.b	'gp@: gmss <XCb`>',13,10
	.dc.b	'XCb`:',13,10
	.dc.b	'	-c	OtBbÑNA',13,10
	.dc.b	'	-r	OtBbNEXN[EWX^̏',13,10
	.dc.b	'	-g[n]	OtBbN̕\ (0:It [1]:I 2:16F 3:64KF)',13,10
	.dc.b	'	-s[n]	USjFOtBbN̏ck (n:[0]-1)',13,10
	.dc.b	'	-t[n]	OtBbÑg[_E (n:0-[50]-100)',13,10
	.dc.b	'	-m	ʃ[h',13,10
	.dc.b	'	-v	o[W\AbZ[W\',13,10
	.dc.b	'	-h	wvbZ[W',13,10
	.dc.b	13,10
	.dc.b	'XCb`͑啶^ʂ܂B',13,10
	.dc.b	13,10
	.dc.b	0

	.text
help:
	movem.l	exec_register,-(sp)
	clr.l	d0
	btst.l	#OPT_HLP,d7
	beq	help_end

	pea	message_help
	bsr	_vprint
	addq.l	#4,sp

	moveq.l	#EXIT_HELP,d0
	movem.l	(sp)+,exec_register
	clr.l	d7			* ̑̃XCb`͖ł
	movem.l	exec_register,-(sp)
help_end:
	movem.l	(sp)+,exec_register
	rts

*-------------------------------------------------------------------------------
* OtBbNʂ̃IIt

	.text
graphic_onoff:
	movem.l	exec_register,-(sp)
	clr.l	d0
	btst.l	#OPT_G,d7
	beq	graphic_onoff_end

	move.l	opt_g_number,d0
	bne	@f

	_TO_SUPER
	and.b	#$60,$e82601		* It
	bset.b	#3,$e80028
	_TO_USER
	clr.l	d0
	bra	graphic_onoff_end

@@:
	subq.l	#2,d0
	bne	@f
	_TO_SUPER
	move.b	#$04,$e80028		* 16F
	move.w	#$0004,$e82400
	bra	graphic_onoff_16

@@:
	subq.l	#1,d0
	bne	@f
	_TO_SUPER
	move.b	#$03,$e80028		* 64KF
	move.w	#$0003,$e82400
	bra	1f

@@:
	_TO_SUPER
	bclr.b	#3,$e80028
	btst.b	#1,$e80028
	beq	graphic_onoff_16

	or.b	#3,$e80028		* 256F͑ΉȂ
	move.w	#3,$e82400
1:
	lea	$e80018,a0		* USjȂʒu␳{g[_E
	move.w	#$ff80,d0
	move.w	d0,(a0)+
	clr.w	(a0)+
	move.w	d0,(a0)+
	clr.w	(a0)+
	move.w	d0,(a0)+
	clr.w	(a0)+
	move.w	d0,(a0)+
	clr.w	(a0)+

	move.w	$e82600,d1
	and.w	#$00ff,d1

	bsr	gpalette_check
	tst.l	d0
	bne	@f
	cmp.l	#$007f8000,gpalette_sum
	bne	@@f			* FLAME.XŕύX
@@:
	or.w	#$1900,d1
@@:
	move.w	d1,$e82600

	move.w	#_GM_AUTO_STATE,d1
	moveq.l	#-1,d2
	bsr	_gm_internal_tgusemd
	cmp.l	#-1,d0
	beq	@f
	cmp.w	#_GM_INTERNAL_MODE,d0
	bne	@f
	swap.w	d0
	btst.l	#0,d0
	bne	@f			* }XN֎~
	btst.l	#1,d0
	beq	@f			* }XNȂ

	move.w	#_GM_MASK_SET,d1
	moveq.l	#-1,d2
	bsr	_gm_internal_tgusemd
@@:
graphic_onoff_16:
	or.w	#$003f,$e82600		* I
	_TO_USER
	clr.l	d0

graphic_onoff_end:
	movem.l	(sp)+,exec_register
	rts

*-------------------------------------------------------------------------------
* g[

	.text
tone:
	movem.l	exec_register,-(sp)
	clr.l	d0
	btst.l	#OPT_T,d7
	beq	tone_end

	bsr	mode_check
	cmp.l	#-1,d0
	beq	tone_end
	tst.w	d0
	beq	@f

	bsr	tone_change_64k
	clr.l	d0
	bra	tone_end
@@:
	bsr	tone_change
	clr.l	d0
tone_end:
	movem.l	(sp)+,exec_register
	rts

*-------------------------------------------------------------------------------
* NA

	.text
clear:
	movem.l	exec_register,-(sp)
	clr.l	d0
	btst.l	#OPT_C,d7
	beq	clear_end

	bsr	mode_check
	cmp.l	#-1,d0
	beq	clear_end
	tst.w	d0
	beq	@f

	bsr	clear_64k		* XN[Zbg܂
	clr.l	d0
	bra	clear_end
@@:
	bsr	clear_16
	clr.l	d0
clear_end:
	movem.l	(sp)+,exec_register
	rts

*-------------------------------------------------------------------------------
* XN[

	.text
scroll:
	movem.l	exec_register,-(sp)
	clr.l	d0
	btst.l	#OPT_R,d7
	beq	scroll_end

	bsr	mode_check
	cmp.l	#-1,d0
	beq	scroll_end
	tst.w	d0
	beq	@f

	clr.l	d0
	bra	scroll_end
@@:
	bsr	scroll_reset
	clr.l	d0
scroll_end:
	movem.l	(sp)+,exec_register
	rts

*-------------------------------------------------------------------------------
* [h`FbN

	.text
mode_check:
	movem.l	d1-d2,-(sp)
	move.w	#_GM_GRAPHIC_MODE_STATE,d1
	moveq.l	#-1,d2			* _~[f[^
	bsr	_gm_internal_tgusemd
	cmp.l	#-1,d0
	beq	@f
	swap.w	d0
@@:
	movem.l	(sp)+,d1-d2
	rts

*-------------------------------------------------------------------------------
* 풓`FbN

	.data
message_gm_not_keep:
	.dc.b	'gm 풓Ă܂B',13,10
	.dc.b	0

	.text
gm_keep_check:
	movem.l	exec_register,-(sp)
	move.w	#_GM_VERSION_NUMBER,d1
	moveq.l	#-1,d2			* _~[f[^
	bsr	_gm_internal_tgusemd
	cmp.l	#-1,d0
	beq	gm_not_keep		* gm Ȃ悧
	cmp.w	#_GM_INTERNAL_MODE,d0
	bne	gm_not_keep		* gm ȊO悧

gm_keep_check_end:
	clr.l	d0
	movem.l	(sp)+,exec_register
	rts

gm_not_keep:
	pea	message_gm_not_keep
	bsr	_error_print
	addq.l	#4,sp
	moveq.l	#EXIT_ERROR_GM_NOT_KEEP,d0
	bra	main_end

*-------------------------------------------------------------------------------
* XNGAUSj̃`FbN

	.text
square_64k_check:
	move.l	d1,-(sp)
	_TO_SUPER
	move.w	$e80028,d0
	and.w	#%111_00011111,d0
	moveq.l	#0,d1
	cmp.w	#$316,d0
	beq	@f
	moveq.l	#1,d1
	btst.b	#1,$e80028
	bne	@f
	btst.b	#1,$e82401
	bne	@f
	moveq.l	#-1,d1
@@:
	_TO_USER
	move.l	d1,d0
	move.l	(sp)+,d1
	rts

*-------------------------------------------------------------------------------
* ftHg

	.text
main:
	movem.l	exec_register,-(sp)
	btst.l	#OPT_M,d7
	bne	main_mode

	bsr	square_64k_check
	tst.l	d0
	beq	@f
	bpl	main_mode

@@:
	clr.l	d0
	tst.l	d7
	bne	main_end

main_mode:
	move.w	#0,-(sp)		* VUW~TPQɂ
	move.w	#16,-(sp)
	DOS	__CONCTRL
	addq.l	#4,sp

	move.w	#2,-(sp)		* ʃNA
	move.w	#10,-(sp)
	DOS	__CONCTRL
	addq.l	#4,sp

	clr.l	d0
main_end:
	movem.l	(sp)+,exec_register
	rts

*-------------------------------------------------------------------------------
* [h TGUSEMD R[

	.text
_gm_internal_tgusemd:
	swap.w	d1
	move.w	#_GM_INTERNAL_MODE,d1
	swap.w	d1
	IOCS	__TGUSEMD
	rts

*-------------------------------------------------------------------------------
* }N`

_HSYNC_WAIT2	.macro
		.local	_HSYNC_WAIT2_loop
_HSYNC_WAIT2_loop:
	tst.b	$e88001
	bpl	_HSYNC_WAIT2_loop
	.endm

_HSYNC_WAIT	.macro
		.local	_HSYNC_WAIT_loop
_HSYNC_WAIT_loop:
	tst.b	$e88001
	bmi	_HSYNC_WAIT_loop
	_HSYNC_WAIT2
	.endm

*-------------------------------------------------------------------------------
* V-DISP݂Đ\Ԃ͑҂

	.text
vdisp_wait:
	btst.b	#4,$e88001
	beq	vdisp_wait
vdisp_wait2:
	btst.b	#4,$e88001
	bne	vdisp_wait2
	rts

*-------------------------------------------------------------------------------
* CRTC NAs
*
* entry:
*   d0.w = NAy[Ww
* broken:
*   d0.l, a0.l

	.text
crtc_gclr:
	lea	$e80480,a0
	move.w	d0,$e8002a
	moveq.l	#%0010,d0
	bclr.b	#3,$e80028
	move.w	d0,(a0)			* CRTC NAs
@@:	move.w	(a0),d0
	btst.l	#1,d0
	beq	@b
	rts

*-------------------------------------------------------------------------------
* CRTC NAI܂ő҂
*
* broken:
*   d0.w, a0.l

	.text
crtc_gclr_wait:
	lea	$e80480,a0
@@:	move.w	(a0),d0
	btst.l	#1,d0
	bne	@b
	rts

*-------------------------------------------------------------------------------
* OtBbÑNAiUSjFj
*
* return:
*   d0.l  = 0 ȂɂĂȂB
*   d0.l != 0 

clear_64k_register	reg	d1-d2

	.text
clear_64k:
	movem.l	clear_64k_register,-(sp)
	_TO_SUPER
	move.l	$e80028,d1
	moveq.l	#$0f,d0
	bsr	vdisp_wait
	bsr	crtc_gclr
	bsr	crtc_gclr_wait
	move.l	d1,$e80028
	_TO_USER

	move.w	#_GM_MASK_CLEAR,d1	* OtBbNȂA}XN͕svB
	moveq.l	#-1,d2
	bsr	_gm_internal_tgusemd
	bsr	scroll_reset		* -r ƕpɃXN[ZbgI
clear_64k_end:
	movem.l	(sp)+,clear_64k_register
	rts

*-------------------------------------------------------------------------------
* OtBbÑNAiPUFj
* 
* return:
*   d0.l  = 0 ȂɂĂȂB
*   d0.l != 0 

clear_16_register	reg	d1

	.text
clear_16:
	movem.l	clear_16_register,-(sp)
	_TO_SUPER
	move.l	$e80028,d1
	moveq.l	#$0f,d0			* _~[
	bsr	vdisp_wait
	bsr	graphic_scroll_register_clear
	bsr	crtc_gclr		* 㔼NA
	bsr	crtc_gclr_wait
	lea	$e80018,a0
	move.l	#512,d0
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	bsr	crtc_gclr		* NA
	bsr	crtc_gclr_wait
	bsr	graphic_scroll_register_clear
	move.l	d1,$e80028
	_TO_USER
clear_16_end:
	movem.l	(sp)+,clear_16_register
	rts

*-------------------------------------------------------------------------------
* OtBbNEXN[EWX^̏

	.text
scroll_reset:
	_TO_SUPER
	bsr	graphic_scroll_register_clear
	_TO_USER
scroll_reset_end:
	rts

*-------------------------------------------------------------------------------
* OtBbNEXN[EWX^NA

	.text
graphic_scroll_register_clear:
	lea	$e80018,a0
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	rts

*-------------------------------------------------------------------------------
* OtBbNpbgUSjpɐݒ肵܂

gpalette_set_register	reg	d0-d2/a0

	.text
gpalette_set:
	movem.l	gpalette_set_register,-(sp)
	lea	$e82000,a0
	move.l	#$00010001,d0
	move.l	#$02020202,d1
	moveq.l	#128-1,d2
	_HSYNC_WAIT
gpalette_set_loop:
	_HSYNC_WAIT2
	move.l	d0,(a0)+
	add.l	d1,d0
	dbra	d2,gpalette_set_loop
	movem.l	(sp)+,gpalette_set_register
	rts

*-------------------------------------------------------------------------------
* OtBbNpbgUSjpׂ̂̂
*
* return
*  d0.l  = 0 USj̃pbgł
*       != 0 ݒlႢ܂

gpalette_check_register	reg	d1-d4/a0

	.text
gpalette_sum:
	.dc.l	0
gpalette_check:
	movem.l	gpalette_check_register,-(sp)
	lea	$e82000,a0
	move.w	#256-1,d2
	clr.l	d3
	clr.w	d4
	clr.w	d0
	_HSYNC_WAIT
gpalette_check_loop:
	_HSYNC_WAIT2
	move.w	(a0)+,d0
	add.l	d0,d3
	eor.w	d0,d4
	dbra	d2,gpalette_check_loop

	move.l	d3,gpalette_sum
	move.w	d4,d0
	ext.l	d0
gpalette_check_end:
	movem.l	(sp)+,gpalette_check_register
	rts

*-------------------------------------------------------------------------------
* USjF̃g[_E

	.text
tone_change_64k:
	move.l	opt_t_number,d0
	bne	@f
	bsr	tone_change_64k_sub_0
	bra	tone_change_64k_end
@@:
	cmp.b	#50,d0
	bne	@f
	bsr	tone_change_64k_sub_50
	bra	tone_change_64k_end
@@:
	cmp.b	#100,d0
	bne	@f
	bsr	tone_change_64k_sub_100
	bra	tone_change_64k_end
@@:
	bsr	tone_change_64k_sub
tone_change_64k_end:
	rts

*-------------------------------------------------------------------------------
* g[_EUSj

tone_change_64k_sub_register	reg	d1-d7/a1

	.bss
	.even
tone_64k_init:
	.ds.w	256
tone_64k_work:
	.ds.w	256

	.text
tone_change_64k_sub:
	movem.l	tone_change_64k_sub_register,-(sp)
	move.l	d0,d6			* 
	_TO_SUPER
	lea	tone_64k_init,a0	* ܂pbg
	move.l	a0,a1
	move.l	#$00010001,d0
	move.l	#$02020202,d1
	moveq.l	#128-1,d2
	_HSYNC_WAIT
@@:
	_HSYNC_WAIT2
	move.l	d0,(a1)+
	add.l	d1,d0
	dbra	d2,@b

	lea	tone_64k_work,a1
	moveq.l	#%11111,d5
	moveq.l	#100,d4
	moveq.l	#%11,d3
	moveq.l	#128-1,d7
tone_change_64k_sub_loop:
	move.w	(a0)+,d0
	moveq.l	#%1,d2			*  I ͏ 1

	ror.w	#1,d0			* Blue
	ror.w	#1,d2
	move.w	d0,d1
	and.w	d5,d1
	mulu.w	d6,d1
	divu.w	d4,d1
	or.w	d1,d2

	ror.w	#5,d0			* Red low
	ror.w	#5,d2
	move.w	d0,d1
	and.w	d3,d1
	mulu.w	d6,d1
	divu.w	d4,d1
	or.w	d1,d2

	ror.w	#3,d0			* Blue
	ror.w	#3,d2
	move.w	d0,d1
	and.w	d5,d1
	mulu.w	d6,d1
	divu.w	d4,d1
	or.w	d1,d2

	ror.w	#5,d0			* Red low
	ror.w	#5,d2
	move.w	d0,d1
	and.w	d3,d1
	mulu.w	d6,d1
	divu.w	d4,d1
	or.w	d1,d2

	ror.w	#2,d2
	move.w	d2,(a1)+

	move.w	(a0)+,d0

	move.w	d0,d1			* Red high
	and.w	#%111,d1
	mulu.w	d6,d1
	divu.w	d4,d1
	move.w	d1,d2

	ror.w	#3,d0			* Green
	ror.w	#3,d2
	move.w	d0,d1
	and.w	d5,d1
	mulu.w	d6,d1
	divu.w	d4,d1
	or.w	d1,d2

	ror.w	#5,d0			* Red high
	ror.w	#5,d2
	move.w	d0,d1
	and.w	#%111,d1
	mulu.w	d6,d1
	divu.w	d4,d1
	or.w	d1,d2

	ror.w	#3,d0			* Green
	ror.w	#3,d2
	move.w	d0,d1
	and.w	d5,d1
	mulu.w	d6,d1
	divu.w	d4,d1
	or.w	d1,d2

	ror.w	#5,d2
	move.w	d2,(a1)+
	dbra	d7,tone_change_64k_sub_loop

	move.w	#$003f,$e82600		* POO
	lea	tone_64k_work,a1
	lea	$e82000,a0		* OtBbNpbgAhX擪
	move.l	#128-1,d0
	_HSYNC_WAIT
@@:
	_HSYNC_WAIT2
	move.l	(a1)+,(a0)+
	dbra	d0,@b

	_TO_USER
	movem.l	(sp)+,tone_change_64k_sub_register
	rts

*-------------------------------------------------------------------------------
* POO̎̓pbg
*

	.text
tone_change_64k_sub_100:
	_TO_SUPER
	move.w	#$003f,$e82600		* POO
	bsr	gpalette_set
	_TO_USER
	rts

*-------------------------------------------------------------------------------
* TO̎̓pbg{[g[_E
*

	.text
tone_change_64k_sub_50:
	_TO_SUPER
	move.w	#$193f,$e82600		* TO
	bsr	gpalette_set
	_TO_USER
	rts

*-------------------------------------------------------------------------------
* OȂNA

	.text
tone_change_64k_sub_0:
	_TO_SUPER
	lea	$e82000,a0		* OtBbNpbgAhX擪
	move.w	#256-1,d0
	_HSYNC_WAIT
@@:
	_HSYNC_WAIT2
	clr.w	(a0)+
	dbra	d0,@b
	_TO_USER
	rts

*-------------------------------------------------------------------------------
* PUF̏ig[_Ej

	.text
tone_change:
	move.w	#_GM_KEEP_PALETTE_GET,d1
	moveq.l	#-1,d2			* _~[f[^(ꉞgmȂ̂)
	bsr	_gm_internal_tgusemd
	cmp.l	#-1,d0
	beq	tone_change_end		* gmΉĂȂ(version0.69ȑO)
	cmp.w	#_GM_INTERNAL_MODE,d0
	bne	tone_change_end
	swap.w	d0
	tst.w	d0
	beq	tone_change_end		* 풓pbg͖
					* i܂OtBbN[hĂȂj
					* LȂ a1.l ɃAhXĂ

	move.l	opt_t_number,d0
	bne	@f
	bsr	tone_change_sub_0
	bra	tone_change_end
@@:
	cmp.b	#50,d0
	bne	@f
	bsr	tone_change_sub_50
	bra	tone_change_end
@@:
	cmp.b	#100,d0
	bne	@f
	bsr	tone_change_sub_100
	bra	tone_change_end
@@:
	bsr	tone_change_sub
tone_change_end:
	rts

*-------------------------------------------------------------------------------
* g[_E܂I
*
* entry:
*   d0.l = 풓pbgɑ΂道iO`POO܂Łj
*   a1.l = 풓pbg̐擪AhXieύX炨EEEj

tone_change_sub_register	reg	d1-d7

	.text
tone_change_sub:
	movem.l	tone_change_sub_register,-(sp)
	move.l	d0,d6			* 
	_TO_SUPER
	moveq.l	#%11111,d5
	moveq.l	#100,d4
	lea	$e82000,a0		* OtBbNpbgAhX擪
	moveq.l	#16-1,d7
	_HSYNC_WAIT
tone_change_sub_loop:
	_HSYNC_WAIT2
	move.w	(a1)+,d0
	ror.w	#1,d0
	move.w	d0,d1
	and.l	d5,d1
	ror.w	#5,d0
	move.w	d0,d2
	and.l	d5,d2
	ror.w	#5,d0
	move.w	d0,d3
	and.l	d5,d3

	mulu.w	d6,d1
	divu.w	d4,d1
	mulu.w	d6,d2
	divu.w	d4,d2
	mulu.w	d6,d3
	divu.w	d4,d3

	lsl.w	#5,d3
	or.w	d2,d3
	lsl.w	#5,d3
	or.w	d1,d3
	add.w	d3,d3
	_HSYNC_WAIT2
	move.w	d3,(a0)+
	dbra	d7,tone_change_sub_loop
	_TO_USER
	movem.l	(sp)+,tone_change_sub_register
	rts

*-------------------------------------------------------------------------------
* POO̎͏풓pbĝ܂
*
* entry:
*   a1.l = 풓pbg̐擪AhXieύX炨EEEj

	.text
tone_change_sub_100:
	_TO_SUPER
	lea	$e82000,a0		* OtBbNpbgAhX擪
	moveq.l	#16-1,d0
	_HSYNC_WAIT
@@:
	_HSYNC_WAIT2
	move.w	(a1)+,(a0)+
	dbra	d0,@b
	_TO_USER
	rts

*-------------------------------------------------------------------------------
* TO͍̎iftHgj
*
* entry:
*   a1.l = 풓pbg̐擪AhXieύX炨EEEj

	.text
tone_change_sub_50:
	_TO_SUPER
	lea	$e82000,a0		* OtBbNpbgAhX擪
	move.w	#%01111_01111_01111_0,d1
	moveq.l	#16-1,d0
	_HSYNC_WAIT
@@:
	_HSYNC_WAIT2
	move.w	(a1)+,d2
	lsr.w	#1,d2
	and.w	d1,d2
	_HSYNC_WAIT2
	move.w	d2,(a0)+
	dbra	d0,@b
	_TO_USER
	rts

*-------------------------------------------------------------------------------
* OȂNA

	.text
tone_change_sub_0:
	_TO_SUPER
	lea	$e82000,a0		* OtBbNpbgAhX擪
	moveq.l	#16-1,d0
	_HSYNC_WAIT
@@:
	_HSYNC_WAIT2
	clr.w	(a0)+
	dbra	d0,@b
	_TO_USER
	rts

*-------------------------------------------------------------------------------
* USjF̏

	.text
shrink:
	movem.l	exec_register,-(sp)
	bsr	mode_check
	tst.w	d0
	beq	shrink_16		* PUFȂsȂ

	clr.l	d0
	btst.l	#OPT_S,d7
	beq	shrink_end

	move.l	#513*1024,-(sp)		* RCTPR
	DOS	__MALLOC
	addq.l	#4,sp
	tst.l	d0
	bmi	program_error_malloc	* vIG[
	move.l	d0,-(sp)
	move.l	d0,a0

	bsr	shrink_sub

	move.l	(sp)+,d0
	move.l	d0,-(sp)
	DOS	__MFREE
	addq.l	#4,sp
	tst.l	d0
	bmi	program_error_mfree	* vIG[
shrink_end:
	movem.l	(sp)+,exec_register
	rts

shrink_16:
	clr.l	d0
	bra	shrink_end

*-------------------------------------------------------------------------------
* OtBbN̉摜k߂
*
* entry:
*   a0.l = buffer top address

	.text
shrink_sub:
	_TO_SUPER
	move.l	opt_s_number,d0
	tst.l	d0
	beq	shrink_sub_0
	subq.l	#1,d0
	beq	shrink_sub_1
	bra	shrink_sub_complete	* Ȃ͂͂ȂEEE

shrink_sub_0:
	bsr	gram_to_buffer
	bsr	buffer_shrink_to_gram
	bra	shrink_sub_complete

shrink_sub_1:
	bsr	gram_to_buffer_not_clear
	bsr	buffer_shrink_to_gram
	bsr	gram_clear

shrink_sub_complete:
	_TO_USER
	rts

*-------------------------------------------------------------------------------
* }N`
*
*   OtBbNPC~Qi㉺j

GLINE_CLEAR	.macro
		.local	gline_clear_loop
	moveq.l	#0,d2
	move.l	d2,d3
	move.l	d2,d4
	move.l	d2,d5
	move.l	d2,d6
	move.l	d2,d7
	move.l	d2,a5
	move.l	d2,a6
	moveq.l	#32-1,d1
gline_clear_loop:
	movem.l	d2-d7/a5-a6,-(a3)
	movem.l	d2-d7/a5-a6,-(a4)
	dbra	d1,gline_clear_loop
	.endm

*-------------------------------------------------------------------------------
* fq`l̓eobt@Ɏ荞ށiNAȂŁj
*
* entry:
*   a0.l = buffer top address

gram_to_buffer_not_clear_register	reg	d0-d7/a0-a6

	.text
gram_to_buffer_not_clear:
	movem.l	gram_to_buffer_not_clear_register,-(sp)

	move.l	a0,a1
	move.l	a0,a2			* ŏIC͂Qd荞
	move.w	#32,a0
	add.l	#$0007fc00,a2
	lea	$c00000,a3
	lea	$c7fc00,a4
	moveq.l	#(32-1)-1,d1
gram_to_buffer_not_clear_start_loop:
	movem.l	(a4)+,d2-d7/a5-a6
	movem.l	d2-d7/a5-a6,(a2)
	movem.l	d2-d7/a5-a6,$400(a2)
	add.w	a0,a2
	dbra	d1,gram_to_buffer_not_clear_start_loop

	movem.l	(a4)+,d2-d7/a5
	move.l	(a4)+,a6
	movem.l	d2-d7/a5-a6,(a2)
	movem.l	d2-d7/a5-a6,$400(a2)
	add.w	a0,a2

	move.w	#(512-1)-1,d0		* c̃C荞
gram_to_buffer_not_clear_loop:
	moveq.l	#32-1,d1		* PC]
gram_to_buffer_not_clear_loop1:
	movem.l	(a3)+,d2-d7/a5-a6
	movem.l	d2-d7/a5-a6,(a1)
	add.w	a0,a1
	dbra	d1,gram_to_buffer_not_clear_loop1
	dbra	d0,gram_to_buffer_not_clear_loop

	movem.l	(sp)+,gram_to_buffer_not_clear_register
	rts

*-------------------------------------------------------------------------------
* Ԃ̂݃OtBbN

gram_clear_register	reg	d0-d7/a0-a6

	.text
gram_clear:
	movem.l	gram_clear_register,-(sp)
	lea	$c00000,a3
	move.l	a3,a4
	add.l	#(255-171+1)*1024,a3	* GRAM̈ʒuij
	add.l	#(256+171+1)*1024,a4	* GRAM̈ʒuij
	move.w	#32,a0
	moveq.l	#0,d2
	move.l	d2,d3
	move.l	d2,d4
	move.l	d2,d5
	move.l	d2,d6
	move.l	d2,d7
	move.l	d2,a5
	move.l	d2,a6

	move.w	#255-171,d0		* Ԃ𖄂߂
gram_clear_loop:
	move.w	#(1024/32)-1,d1		* PC
gram_clear_loop1:
	movem.l	d2-d7/a5-a6,-(a3)
	movem.l	d2-d7/a5-a6,-(a4)
	dbra	d1,gram_clear_loop1
	lea	$800(a4),a4
	dbra	d0,gram_clear_loop
gram_clear_end:
	movem.l	(sp)+,gram_clear_register
	rts

*-------------------------------------------------------------------------------
* fq`l̓eobt@Ɏ荞
*
* entry:
*   a0.l = buffer top address

gram_to_buffer_register	reg	d0-d7/a0-a6

	.text
gram_to_buffer:
	movem.l	gram_to_buffer_register,-(sp)

	move.l	a0,a1			* ŏ̂PCo
	move.l	a0,a2			* ŏIC͂Qd荞
	move.w	#32,a0
	add.l	#$0007fc00,a2
	lea	$c00000,a3
	lea	$c7fc00,a4
	moveq.l	#(32-1)-1,d1
gram_to_buffer_start_loop:
	movem.l	(a3)+,d2-d7/a5-a6
	movem.l	d2-d7/a5-a6,(a1)
	movem.l	(a4)+,d2-d7/a5-a6
	movem.l	d2-d7/a5-a6,(a2)
	movem.l	d2-d7/a5-a6,$400(a2)
	add.w	a0,a1
	add.w	a0,a2
	dbra	d1,gram_to_buffer_start_loop

	movem.l	(a3)+,d2-d7/a5-a6
	movem.l	d2-d7/a5-a6,(a1)
	movem.l	(a4)+,d2-d7/a5
	move.l	(a4)+,a6
	movem.l	d2-d7/a5-a6,(a2)
	movem.l	d2-d7/a5-a6,$400(a2)
	add.w	a0,a1
	add.w	a0,a2

	GLINE_CLEAR

	lea	$400(a3),a3
	lea	$fffffc00(a4),a4
	lea	$fffff800(a2),a2

	move.w	#(256-1)-1,d0		* c̃C荞
gram_to_buffer_loop:
	moveq.l	#32-1,d1		* PC]
gram_to_buffer_loop1:
	movem.l	(a3)+,d2-d7/a5-a6
	movem.l	d2-d7/a5-a6,(a1)
	movem.l	(a4)+,d2-d7/a5-a6
	movem.l	d2-d7/a5-a6,(a2)
	add.w	a0,a1
	add.w	a0,a2
	dbra	d1,gram_to_buffer_loop1

	GLINE_CLEAR

	lea	$400(a3),a3
	lea	$fffffc00(a4),a4
	lea	$fffff800(a2),a2
	dbra	d0,gram_to_buffer_loop

	movem.l	(sp)+,gram_to_buffer_register
	rts

*-------------------------------------------------------------------------------
* obt@̓eckĂfq`lɏ
*
* entry:
*   a0.l = buffer top address

buffer_shrink_to_gram_register	reg	d0-d7/a0-a6

	.text
buffer_shrink_to_gram:
	movem.l	buffer_shrink_to_gram_register,-(sp)

	move.l	a0,a1
	move.l	a0,a2
	add.l	#255*1024,a1		* obt@ʒuij
	add.l	#257*1024,a2		* obt@ʒuij
	lea	$c3fc00,a3		* GRAM̈ʒuij
	lea	$c40000,a4		* GRAM̈ʒuij

	lea	shrink_div3_table_g,a0	* Ze[u
	lea	shrink_div3_table_r,a5
	lea	shrink_div3_table_b,a6

	move.w	#%1111100000111110,d4	* pbg}XN
	move.w	#%0000011111000000,d5
	clr.w	d6			* fAa𓯎ɌvẐł̎g[NWX^
					* d6.w ̏ʃoCg͏ɂOɂ

	bsr	shrink_put_down		* 傤ǐ^
	move.w	#((513/3)/2)-1,d7	* [v
buffer_shrink_to_gram_loop:
	bsr	shrink_put_up
	bsr	shrink_put_down
	dbra	d7,buffer_shrink_to_gram_loop

	movem.l	(sp)+,buffer_shrink_to_gram_register
	rts

*-------------------------------------------------------------------------------
* ʔɕ\̃Cƍ

	.text
shrink_put_up:
	exg.l	a1,a2
	exg.l	a3,a4
	bsr	shrink_put_sub
	exg.l	a1,a2
	exg.l	a3,a4
	lea	$fffff400(a1),a1
	lea	$00000400(a2),a2
	lea	$fffff800(a3),a3
	rts

*-------------------------------------------------------------------------------
* ʔɕ\̃Cƍ

	.text
shrink_put_down:
	bsr	shrink_put_sub
	lea	$fffff800(a1),a1
	lea	$fffff800(a3),a3
	rts

*-------------------------------------------------------------------------------
* QFP̊ŏ܂͉̃Cƍ
*
* entry:
*   a1.l = obt@AhXiƍj
*   a2.l = obt@AhXiƍj
*   a3.l = fq`lAhXiƍj
*   a4.l = fq`lAhXiƍj
*
*   ̃[`xԗƂĂ

	.data
	.even
					* ̃e[ũ|Cg
	.ifndef	__SHRINK_HIGH_SPEED__
shrink_div3_table_g:
_DIV3_COUNT	set	0
	.rept	32
	.dc.w	(_DIV3_COUNT<<11),(_DIV3_COUNT<<11),(_DIV3_COUNT<<11)
_DIV3_COUNT	set	_DIV3_COUNT+1
	.endm

shrink_div3_table_r:
_DIV3_COUNT	set	0
	.rept	32
	.dc.w	(_DIV3_COUNT<<6),(_DIV3_COUNT<<6),(_DIV3_COUNT<<6)
_DIV3_COUNT	set	_DIV3_COUNT+1
	.endm

	.else

shrink_div3_table_g:
shrink_div3_table_r	equ	*+2
_DIV3_COUNT	set	0
	.rept	32
	.dc.w	(_DIV3_COUNT<<11)
	.dc.w	(_DIV3_COUNT<<6)
		.rept	32-2
		.dc.w	0
		.endm
	.dc.w	(_DIV3_COUNT<<11)
	.dc.w	(_DIV3_COUNT<<6)
		.rept	32-2
		.dc.w	0
		.endm
	.dc.w	(_DIV3_COUNT<<11)
	.dc.w	(_DIV3_COUNT<<6)
		.rept	32-2
		.dc.w	0
		.endm
_DIV3_COUNT	set	_DIV3_COUNT+1
	.endm
	.endif		* for __SHRINK_HIGH_SPEED__

shrink_div3_table_b:
_DIV3_COUNT	set	0
	.rept	32
	.dc.w	(_DIV3_COUNT<<1),(_DIV3_COUNT<<1),(_DIV3_COUNT<<1)
_DIV3_COUNT	set	_DIV3_COUNT+1
	.endm

	.text
shrink_put_sub:
	move.w	#512-1,d1
shrink_put_sub_loop:
	move.w	$400(a1),d2		* Q̂Pō킹J[
	move.w	(a1),d0			* x[XJ[

	move.w	d2,d3
	and.w	d4,d0
	and.w	d4,d3
	ror.w	#1,d3
	add.w	d3,d0

	move.b	d0,d6			* Ԓ wtOɃf[^Ă̂
	sf.b	d0			* add.w d6,d6 悾Ɖ摜ςɂȂ
	.ifndef	__SHRINK_HIGH_SPEED__
	roxl.w	#8,d0
	.else
	roxr.w	#4,d0
	.endif
	move.w	(a0,d0.w),d0
	add.w	d6,d6
	or.w	(a6,d6.w),d0

	move.w	(a1)+,d3
	and.w	d5,d3
	and.w	d5,d2
	add.w	d3,d3
	add.w	d2,d3

	.ifndef	__SHRINK_HIGH_SPEED__
	ror.w	#5,d3
	.endif

	or.w	(a5,d3.w),d0
	move.w	d0,(a3)+

	move.w	$fffffc00(a2),d2	* Q̂Pō킹J[
	move.w	(a2),d0			* x[XJ[

	move.w	d2,d3
	and.w	d4,d0
	and.w	d4,d3
	ror.w	#1,d3
	add.w	d3,d0

	move.b	d0,d6			* Ԓ wtOɃf[^Ă̂
	sf.b	d0			* add.w d6,d6 悾Ɖ摜ςɂȂ
	.ifndef	__SHRINK_HIGH_SPEED__
	roxl.w	#8,d0
	.else
	roxr.w	#4,d0
	.endif
	move.w	(a0,d0.w),d0
	add.w	d6,d6
	or.w	(a6,d6.w),d0

	move.w	(a2)+,d3
	and.w	d5,d3
	and.w	d5,d2
	add.w	d3,d3
	add.w	d2,d3

	.ifndef	__SHRINK_HIGH_SPEED__
	ror.w	#5,d3
	.endif

	or.w	(a5,d3.w),d0
	move.w	d0,(a4)+

	dbra	d1,shrink_put_sub_loop
	rts

*-------------------------------------------------------------------------------

	.ifndef	__OS_VERCHK__
*-------------------------------------------------------------------------------
* ftHgEEE

	.text
program_ver_check:
	rts

*-------------------------------------------------------------------------------
	.else
	.ifndef	__HUMAN_V2__
*-------------------------------------------------------------------------------
* nr̃o[W`FbN

	.data
message_ver_error:
	.dc.b	'nr̃o[WÂ那',13,10
	.dc.b	'Human68k version 3.00ȍ~gĂˁB',13,10,0

	.text
program_ver_check:
	DOS	__VERNUM
	cmp.w	#$0300,d0
	bcs	program_ver_check_error
	rts
program_ver_check_error:
	pea	message_ver_error
	DOS	__PRINT
	addq.l	#4,sp
	move.w	#EXIT_ERROR_OS_VERSION,-(sp)
	DOS	__EXIT2

	.else
*-------------------------------------------------------------------------------

	.data
message_ver_error:
	.dc.b	'nr̃o[WV那',13,10
	.dc.b	'Human68k version 3.00ȑOgĂˁB',13,10,0

	.text
program_ver_check:
	DOS	__VERNUM
	cmp.w	#$0300,d0
	bcc	program_ver_check_error
	rts
program_ver_check_error:
	pea	message_ver_error
	DOS	__PRINT
	addq.l	#4,sp
	move.w	#EXIT_ERROR_OS_VERSION,-(sp)
	DOS	__EXIT2

*-------------------------------------------------------------------------------
	.endif		* for __HUMAN_V2__
	.endif		* for __OS_VERCHK__


*-------------------------------------------------------------------------------
* G[

	.data
message_program_error:
	.dc.b	'I܂B',13,10
	.dc.b	0

	.text
program_error:
	move.w	d0,-(sp)
	move.l	a0,-(sp)
	DOS	__PRINT
	addq.l	#4,sp
	pea	message_program_error
	DOS	__PRINT
	addq.l	#4,sp
	DOS	__EXIT2

	.data
message_program_error_setblock:
	.dc.b	'ubN̕ύXł܂B',13,10
	.dc.b	0
message_program_error_malloc:
	.dc.b	'ubNmۂł܂B',13,10
	.dc.b	0
message_program_error_mfree:
	.dc.b	'ubNł܂B',13,10
	.dc.b	0

	.text
program_error_setblock:
	lea	message_program_error_setblock,a0
	move.w	#EXIT_ERROR_SETBLOCK,d0
	bra	program_error

program_error_malloc:
	lea	message_program_error_malloc,a0
	move.w	#EXIT_ERROR_MALLOC,d0
	bra	program_error

program_error_mfree:
	lea	message_program_error_mfree,a0
	move.w	#EXIT_ERROR_MFREE,d0
	bra	program_error

*-------------------------------------------------------------------------------


*
	.text
	.even
program_text_end:
	.data
	.even
program_data_end:
	.bss
	.even
program_bss_end:
	.stack
	.even
program_stack_end:
	.text
*

	.end	program_start
